#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

//
//		stringをseparator文字で分割
//
class SeparateString {
	public:

	char * sep_c;			//	separator文字を格納するための配列
	int n_sep_c;			//	separator文字の数
	vector<string> list_str;	//	分割された文字列を格納するためのvector<string>型コンテナ

	SeparateString(): n_sep_c(0), sep_c(NULL) {};
	virtual ~SeparateString(){
		if(sep_c != NULL) delete [] sep_c;
		if(!list_str.empty()) list_str.clear();
	}

	virtual vector<string>::size_type get_size(){
			return list_str.size();
		}

	virtual void SetSeparator( char * c, int n_c ){
		if(sep_c != NULL) delete [] sep_c;
		n_sep_c = n_c;
		int pos = 0;
		sep_c = new char[n_sep_c];
		for (int i = 0; i < n_sep_c; i++){
			sep_c[i] = c[i];
		}
	}
	//
	//	separator文字と一致するかどうかの判定
	//
	bool check_char( char c ){
		bool v = false;
		for (int i = 0; i < n_sep_c; i++)
			if (c == sep_c[i]) v = true;
		return v;
	}
	//
	//	stringをseparator文字で分割してvector<string>型コンテナlist_strに格納する
	//
	virtual void SetString( string & str ){
		if(!list_str.empty()) list_str.clear();
		if(str.length() > 0){
			int s_pos = -1, e_pos = -1;
			while(true){
				do{
					e_pos++;
				}while((!check_char(str[e_pos])) && (e_pos < (str.length() - 1)));
				if (!check_char(str[e_pos])){
					 e_pos++;
					if (!check_char(str[e_pos])) e_pos++;
				}
				if((e_pos - s_pos) > 1){
					list_str.push_back( str.substr( s_pos+1, e_pos - s_pos - 1 ) );
				}else{
					list_str.insert(list_str.end(), 1, "");
				}
				if(e_pos >= (str.length() - 1)) break;
				s_pos = e_pos;
			}
		}
	}
	//
	//	分割された文字列から空文字列でないipos番目の文字列を返す
	//	該当する文字列がないときは、空の文字列""を返す。
	//
	virtual void SeekStr( int ipos, string & s ){
		string v = "";
		int ck_cnt = -1;
		if(!list_str.empty()){
			for(vector<string>::iterator ip = list_str.begin(); ip != list_str.end(); ip++){
				if((*ip).length() > 0) ck_cnt++;
				if(ck_cnt == ipos){
					v = *ip;
					break;
				}
			}
		}
		s = v;
	}
	//
	//	分割されたipos番目の文字列（空文字列を含む）を返す。
	//
	virtual void SeekStrAll( int ipos, string & s ){
		string v = "";
		int ck_cnt = -1;
		if(!list_str.empty()){
			for(vector<string>::iterator ip = list_str.begin(); ip != list_str.end(); ip++){
				ck_cnt++;
				if(ck_cnt == ipos){
					v = *ip;
					break;
				}
			}
		}
		s = v;
	}
};



class myexcept: public std::exception {
	public:
		string vsc;

		myexcept( const char * sc ): vsc(sc) { }
		virtual ~myexcept() throw() {}
		string & what() { return vsc; }		
};

int main(){
	char fl_nm[100];
	cout << "File name = ";
	cin >> fl_nm;
	ifstream fin;
	fin.open(fl_nm);
	//
	//	１回目の読み込みと文字列の処理
	//
	cout << endl << "\t\t Step-1" << endl;
	char sepchr[] = {' ', '\t', ','};
	SeparateString sepstr;
	sepstr.SetSeparator( sepchr, 3 );	
	string str;
	while(true){
		getline(fin, str);
		if(fin.fail()) break;
		cout << endl << str << endl;
		sepstr.SetString( str );
		cout << "Size = " << sepstr.get_size() << endl;
		for(int i = 0; i < sepstr.get_size(); i++){
			string tstr;
			sepstr.SeekStrAll( i, tstr );
			cout << " <" << tstr << ">";
		}
		cout << endl;
	}
	fin.close();
	//
	//	２回目の読み込みと文字列の処理
	//
	cout << endl << "\t\t Step-2" << endl;
	fin.open(fl_nm);
	char sepchr1[] = {' ', '\t'};
	sepstr.SetSeparator( sepchr, 2 );	
	while(true){
		getline(fin, str);
		if(fin.fail()) break;
		cout << endl << str << endl;
		sepstr.SetString( str );
		cout << "Size = " << sepstr.get_size() << endl;
		for(int i = 0; i < sepstr.get_size(); i++){
			string tstr;
			sepstr.SeekStrAll( i, tstr );
			cout << " <" << tstr << ">";
		}
		cout << endl;
	}
	fin.close();

	return 0;
}
